/* Music LALF ADPCM Table Maker */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{
	int i;
	int mode=0;
	static unsigned char dattbl[0x400];
	static unsigned char pcmtbl[0x100];
	int start=0x0000,end=0x0000;
	unsigned char pcmname[0x11];
	char vname[FILENAME_MAX];

	FILE *fp = NULL;
	FILE *fx = NULL;

	fprintf(stderr, "MusicLALF ADPCM Table maker\n",argv[0]);
	if (argc>2)
	{
		fprintf(stderr, "Usage: %s [-n]\n\t-n : ADPCMf[^t@C݂̑`FbNȂ\n",argv[0]);
		return 1;
	}
	if (argc>1)
	{
		if (strcmp(argv[1],"-n")==0) mode=1;
	}

	// PCM`t@C̃I[v
	if ((fp=fopen("DATA","rb"))==NULL)
	{ 
		fprintf(stderr, "Not found \"DATA\".\n");
		return 1;
	}
	fread(dattbl,1,0x400,fp);
	fclose(fp);

	// o̓t@C(XML)̃I[v
	if ((fx=fopen("pcmxml.txt","wb"))==NULL)
	{ 
		fprintf(stderr, "Can't open output file!!.\n");
		return 1;
	}

	// C
	for (i=0; i<0x40; i++)
	{
		if (dattbl[i*0x20]==0x00) break;		// Ō
		// t@C̑݃`FbN
		if (mode!=1)
		{
			sprintf(vname,"VOICE.%d",i+1);
			if ((fp=fopen(vname,"rb"))==NULL)
			{ 
				fprintf(stderr, "Not found \"%s\"\n",vname);
				continue;
			}
			fclose(fp);
		}
		memcpy(pcmname,&dattbl[i*0x20],0x10);	// PCMF
		pcmname[0x10]='\0';
		end = start+((((dattbl[i*0x20+0x12]+dattbl[i*0x20+0x13]*0x100)-(dattbl[i*0x20+0x10]+dattbl[i*0x20+0x11]*0x100)))>>2);
		pcmtbl[i*8]   = start&0xff;				// X^[gAhX
		pcmtbl[i*8+1] = start>>8;
		pcmtbl[i*8+2] = end&0xff;				// XgbvAhX
		pcmtbl[i*8+3] = end>>8;
		pcmtbl[i*8+6] = dattbl[i*0x20+0x1b];	// PCM[h
		printf("PCM NO.%2d:%-16s ADR:%05x\n",i+1,pcmname,start*4);
		fprintf(fx,"\t\t\t<rom type=\"adpcm\" offset=\"0x%05x\">voice.%d</rom>\r\n",start*4,i+1);
		start=end+4;
	}
	fclose(fx);
	fp = fopen("PCMTBL", "wb");
	if (fwrite(pcmtbl, 1, 0x100, fp)!=0x100)
	{
		fprintf(stderr, "Write error !!\n");
		return 1;
	}
	fclose(fp);
	return 0;
}

